> For the complete documentation index, see [llms.txt](https://help.security.gallagher.com/knowledge-hub/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://help.security.gallagher.com/knowledge-hub/developer/rest-api/macros.md).

# Macros

These methods give you read access to basic data about the Macros in the Command Centre database, and let you run them.

Reading the section 'Understanding Macros' in the Configuration client help is an excellent way to do exactly that.

The first use case below introduces the main entry point. It is a paginated search interface that gives you any number of macros, each containing the fields you ask for in the query, including (for example) the URL you need to run the macro.

You cannot use the REST API to change a macro's schedule. You must use the Command Centre or Configuration client for that.

### Overrides

You can use this API to run a macro. That is the only override they accept.

### Macro status flags

Being very simple creatures, macros normally bear no flags of status but an experimental addition to version 9.30 adds the flag `closed` while a macro is running. If you have subscribed to status updates you will see this flag flash past, but if you simply ask for a macro's status on your own schedule you are very unlikely to strike it during the extremely brief time it is active.

This is a feature meant for Gallagher clients only. A future version may change the flag's name so we suggest avoiding it for now.

#### Macro flag rules

* Do not rely on `closed` meaning that the macro is running.

### Use cases

#### Listing Macros

1. `GET /api`.
2. Follow the link at `features.macros.macros.href` ↪, appending a search term (described below) to narrow the results if your installation has a lot of macros.
3. Process the results, following the `next` link until there isn't one.

#### Running a Macro

1. Find the href for the macro using the process above.
2. GET it.
3. If your operator is able to run the macro, the results will contain a URL at `commands.run.href`. POST to that to run the macro. No body required.

### Licensing

All the POSTs that override items require RESTOverrides.

If you have RESTOverrides but not RESTStatus in 8.60 or later, the GETs return enough information to let you find the item you want to override but they do not return its status. In 8.50 and older, the GET will fail without RESTStatus.

The RESTOverrides and RESTStatus licences do not overlap: to watch the status of an item as well as override it, you will need both.

## Search macros

> This returns a summary of the macros matching your search criteria.\
> \
> The result will contain no more than 100 or 1000 macros (depending on your version), or as\
> many as you asked for; you should follow the \`next\` link, if it is\
> present, to collect the next batch.\
> \
> If your result set is empty it means your operator does not have the privilege to view any\
> macros, such as 'View Site', 'Run Macros', or 'Schedule and Run Macros'.  Perhaps there are\
> no macros in the divisions in which your operator has privileges, or your operator has no\
> privileges at all.\
> \
> When you have loaded them all there will be no \`next\` link.\
> \
> Do not code this URL into your application.  Take it from the 'href' field in the\
> \`features.macros.macros\` section of \`/api\`.<br>

```json
{"openapi":"3.2.0","info":{"title":"Command Centre REST API","version":"2.0"},"tags":[{"name":"Macros","description":"These methods give you read access to basic data about the Macros in the Command\nCentre database, and let you run them.\n\nReading the section 'Understanding Macros' in the Configuration client help is an\nexcellent way to do exactly that.\n\nThe first use case below introduces the main entry point.  It is a paginated search interface\nthat gives you any number of macros, each containing the fields you ask for in the query,\nincluding (for example) the URL you need to run the macro.\n\nYou cannot use the REST API to change a macro's schedule.  You must use the Command\nCentre or Configuration client for that.\n\n## Overrides\n\nYou can use this API to run a macro.  That is the only override they accept.\n\n## Macro status flags\n\nBeing very simple creatures, macros normally bear no flags of status but an experimental\naddition to version 9.30 adds the flag `closed` while a macro is running.  If you have\nsubscribed to status updates you will see this flag flash past, but if you simply ask for a\nmacro's status on your own schedule you are very unlikely to strike it during the extremely\nbrief time it is active.\n\nThis is a feature meant for Gallagher clients only.  A future version may change the flag's\nname so we suggest avoiding it for now.\n\n### Macro flag rules\n\n* Do not rely on `closed` meaning that the macro is running.\n\n## Use cases\n\n### Listing Macros\n1. `GET /api`.\n2. Follow the link at `features.macros.macros.href`\n   [↪](macros#get-api-macros), appending a search term (described below) to\n   narrow the results if your installation has a lot of macros.\n3. Process the results, following the `next` link until there isn't one.\n\n### Running a Macro\n1. Find the href for the macro using the process above.\n2. GET it.\n4. If your operator is able to run the macro, the results will contain a URL at\n   `commands.run.href`.  [POST](macros#post-api-macros-id-run) to that to run the macro.\n   No body required.\n\n## Licensing\n\nAll the POSTs that override items require RESTOverrides.\n\nIf you have RESTOverrides but not RESTStatus in 8.60 or later, the GETs return enough\ninformation to let you find the item you want to override but they do not return its status.  In\n8.50 and older, the GET will fail without RESTStatus.\n\nThe RESTOverrides and RESTStatus licences do not overlap: to watch the status of an item as well\nas override it, you will need both.\n"}],"servers":[{"url":"https://127.0.0.1:8904"}],"security":[{"API_key":[]},{"basic":[]}],"components":{"securitySchemes":{"API_key":{"type":"apiKey","name":"Authorization","in":"header","description":"\nClients authenticate by including a pre-shared API key in the `Authorization` header of each\nrequest after an authorisation method of `GGL-API-KEY`:\n\n`Authorization: GGL-API-KEY C774-B01F-D695-AA4B-215F-A158-AC22-ADEB`\n\nFor a fuller description see [API authentication](api-authentication).\n"},"basic":{"type":"http","scheme":"basic","description":"This is HTTP Basic authentication using a blank username and the API key as the password.\n\nExample:  `Authorization: Basic OkM3NzQtQjAxRi1ENjk1LUFBNEItMjE1Ri1BMTU4LUFDMjItQURFQg==`\n\nThat example is equivalent to the example in the description of the api_Key method:\nprepending a colon to the API key beginning with `C774` then encoding it into Base64\nproduces the 56 characters beginning with `OkM3`.\n\nThe colon is a separator between a username, which is blank in our case, and the password,\nwhich is our API key.\n\nFor a fuller description see [API authentication](api-authentication)\n"}},"parameters":{"sort":{"name":"sort","in":"query","schema":{"type":"string","enum":["id","name","-id","-name"]},"required":false,"description":"Changes the sort field between database ID and name.\n\nIf you prefix `id` or `name` with a minus sign (ASCII 45), the sort order is reversed.\n\nThere are two very strong reasons to sort by ID:\n\n1. Sorting by name carries a risk of missing or duplicating objects if your result set spans\n   multiple pages and another operator is editing the database while your REST client is\n   enumerating them.  This is known as \"page drift.\"  Sorting by ID does not carry that risk.\n2. Following a `next` link is _dramatically_ quicker when sorting by ID.\n\nWe _strongly_ recommend sorting by ID.  In case you were still in doubt, we will do that by\ndefault in a future version of Command Centre.\n\nThe server silently ignores anything except the options listed here.\n"},"top":{"name":"top","in":"query","required":false,"schema":{"type":"integer","minimum":1},"description":"Limits the results to no more than this many items per page.\n\nOlder versions of Command Centre returned 100 items per page in the absence of this parameter.  That is acceptable for GUI\napplications that will only display the first page, but for integrations that intend to\nproceed through the entire database it causes a lot of chatter.\n\n8.70 and later versions will default to 1000 items per request.  This is about where a graph\nof throughput versus page size begins to level out.\n"},"name":{"name":"name","in":"query","schema":{"type":"string"},"description":"Limits the returned items to those with a name that matches this string.  Without surrounding\nquotes or a percent sign or underscore, it is a substring match; surround the parameter with\ndouble quotes `\"...\"` for an exact match.  Without quotes, a percent sign `%` will match any\nsubstring and an underscore will match any single character.\n\nThe search is always case-insensitive.  Results are undefined if you do a substring search for\nthe empty string (`name=`).  You will receive no items if you search for those with no name\n(`name=\"\"`), as all items must have a name.\n\nSearch parameters are ANDed together.\n"},"division":{"name":"division","in":"query","required":false,"schema":{"type":"array","items":{"type":"string"}},"style":"form","explode":false,"description":"Limits the returned items to those that are in these divisions.\n\nThat includes all the items in those divisions' child divisions, because Command Centre treats\nitems as though they are also in their division's parent, and its parent, and so on up to the\nroot division.\n\nSeparate the IDs of the divisions in you are interested with commas.  Item IDs are short\nalphanumeric strings, not URLs.\n\nResults are undefined if you provide an ID that is not in the form of a division ID.\n\nSearch parameters are ANDed together.\n"},"directDivision":{"name":"directDivision","in":"query","required":false,"schema":{"type":"array","items":{"type":"string"}},"style":"form","explode":false,"description":"Restricts items to those whose division is in this list.\n\nUnlike `division=`, it does not follow ancestry.  That means it will limit the search to items\nthat are directly assigned to the divisions you list, whereas `division` (without the\n`direct`) will also include items that are assigned to their descendants.\n\nList the IDs of the divisions you are interested in separated by commas.  Item IDs are short\nalphanumeric strings, not URLs.\n\nBecause this is the first query parameter we added that contains a capital letter, this will\nbe the first time you have had to think about case sensitivity.  `directDivision` works,\n`directdivision` does not.\n\nResults are undefined if you provide an ID that is not in the form of a division ID.\n\nSearch parameters are ANDed together.\n\nAdded in 9.20.\n"},"description":{"name":"description","in":"query","required":false,"schema":{"type":"string"},"description":"Limits the returned items to those with a description that matches this string.  By default it\nis a substring match; surround it with double quotes `\"...\"` for an exact match.  A `_` will\nmatch any single character, and a `%` will match any substring.  With or without quotes,\nhaving either of these wildcards in the string will anchor it at both ends as though you had\nsurrounded it with `\"`.\n\nThe search is always case-insensitive.  Results are undefined if you search for the empty\nstring (`description=` or `description=\"\"`).\n\nSearch parameters are ANDed together.\n"},"pos":{"name":"pos","in":"query","required":false,"schema":{"type":"integer"},"description":"Reserved for internal use.  You may see it in URLs you receive from the server, but you must never add it yourself."},"skip":{"name":"skip","in":"query","required":false,"schema":{"type":"integer"},"description":"Reserved for internal use.  Do not add it to your queries."}},"schemas":{"MacroSearch":{"title":"Macro search","description":"An array of macro summaries, and a `next` link for more.","properties":{"results":{"type":"array","description":"An array of macro summaries.","items":{"$ref":"#/components/schemas/MacroSummary"}},"next":{"type":"object","description":"The link to the next page.  Absent if you have retrieved them all.","properties":{"href":{"type":"string","format":"uri-reference"}}}}},"MacroSummary":{"title":"Macro summary","description":"`/api/macros` returns an array of these.  It is a subset of what you get from a\nmacro's detail page at `/api/macros/{id}` (linked as the href in this object).\n","properties":{"href":{"type":"string","format":"uri-reference","description":"A link to a [macro detail](models#macrodetail) object for this macro.\n"},"id":{"type":"string","description":"An alphanumeric identifier, unique to the server.  This is the ID to use in the `source`\nparameter of [event filters](events#get-api-events) if you are only\ninterested in events from particular macros (which would be unusual, since macros do not\ngenerate many events).\n"},"name":{"type":"string"}}}},"responses":{"403nolicence":{"description":"A server running 8.50 or earlier is missing the RESTStatus licence.  A server running 8.60\nor later is missing both the RESTStatus and RESTOverrides licences.  One of those is enough\nfor this API call in 8.60 and later.\n"}}},"paths":{"/api/macros":{"get":{"tags":["Macros"],"summary":"Search macros","description":"This returns a summary of the macros matching your search criteria.\n\nThe result will contain no more than 100 or 1000 macros (depending on your version), or as\nmany as you asked for; you should follow the `next` link, if it is\npresent, to collect the next batch.\n\nIf your result set is empty it means your operator does not have the privilege to view any\nmacros, such as 'View Site', 'Run Macros', or 'Schedule and Run Macros'.  Perhaps there are\nno macros in the divisions in which your operator has privileges, or your operator has no\nprivileges at all.\n\nWhen you have loaded them all there will be no `next` link.\n\nDo not code this URL into your application.  Take it from the 'href' field in the\n`features.macros.macros` section of `/api`.\n","parameters":[{"$ref":"#/components/parameters/sort"},{"$ref":"#/components/parameters/top"},{"$ref":"#/components/parameters/name"},{"$ref":"#/components/parameters/division"},{"$ref":"#/components/parameters/directDivision"},{"$ref":"#/components/parameters/description"},{"name":"fields","in":"query","required":false,"style":"form","explode":false,"description":"This instructs the server to return only these fields in the search results.  The values you can list are the same as the field\nnames in the details page.  Using this you can return everything on the summary page that you\nwould find on the details page.  Separate values with commas.\n\nUse the special value `defaults` to return the fields you would have received had you not given\nthe parameter at all.  Obviously only do that if you have more to add.\n\nTreat the string matches as case-sensitive.\n\nIn v8.00 you will receive the href and internal ID even if you did not ask for them.  In 8.10\nand later you will only get what you asked for.  If you are going to send the `fields`\nparameter and need the href or ID, be explicit.\n","schema":{"type":"string","enum":["href","id","name","description","division","commands","notes","updates","defaults"]}},{"$ref":"#/components/parameters/pos"},{"$ref":"#/components/parameters/skip"}],"responses":{"200":{"description":"Success.  See the note in the description about privileges if your result set is empty.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/MacroSearch"}}}},"403":{"$ref":"#/components/responses/403nolicence"}}}}}}
```

## Get details of a macro

> This returns the detail of one macro.\
> \
> Follow the 'href' field in a \[macro summary]\(models#macrosummary) to get here.<br>

```json
{"openapi":"3.2.0","info":{"title":"Command Centre REST API","version":"2.0"},"tags":[{"name":"Macros","description":"These methods give you read access to basic data about the Macros in the Command\nCentre database, and let you run them.\n\nReading the section 'Understanding Macros' in the Configuration client help is an\nexcellent way to do exactly that.\n\nThe first use case below introduces the main entry point.  It is a paginated search interface\nthat gives you any number of macros, each containing the fields you ask for in the query,\nincluding (for example) the URL you need to run the macro.\n\nYou cannot use the REST API to change a macro's schedule.  You must use the Command\nCentre or Configuration client for that.\n\n## Overrides\n\nYou can use this API to run a macro.  That is the only override they accept.\n\n## Macro status flags\n\nBeing very simple creatures, macros normally bear no flags of status but an experimental\naddition to version 9.30 adds the flag `closed` while a macro is running.  If you have\nsubscribed to status updates you will see this flag flash past, but if you simply ask for a\nmacro's status on your own schedule you are very unlikely to strike it during the extremely\nbrief time it is active.\n\nThis is a feature meant for Gallagher clients only.  A future version may change the flag's\nname so we suggest avoiding it for now.\n\n### Macro flag rules\n\n* Do not rely on `closed` meaning that the macro is running.\n\n## Use cases\n\n### Listing Macros\n1. `GET /api`.\n2. Follow the link at `features.macros.macros.href`\n   [↪](macros#get-api-macros), appending a search term (described below) to\n   narrow the results if your installation has a lot of macros.\n3. Process the results, following the `next` link until there isn't one.\n\n### Running a Macro\n1. Find the href for the macro using the process above.\n2. GET it.\n4. If your operator is able to run the macro, the results will contain a URL at\n   `commands.run.href`.  [POST](macros#post-api-macros-id-run) to that to run the macro.\n   No body required.\n\n## Licensing\n\nAll the POSTs that override items require RESTOverrides.\n\nIf you have RESTOverrides but not RESTStatus in 8.60 or later, the GETs return enough\ninformation to let you find the item you want to override but they do not return its status.  In\n8.50 and older, the GET will fail without RESTStatus.\n\nThe RESTOverrides and RESTStatus licences do not overlap: to watch the status of an item as well\nas override it, you will need both.\n"}],"servers":[{"url":"https://127.0.0.1:8904"}],"security":[{"API_key":[]},{"basic":[]}],"components":{"securitySchemes":{"API_key":{"type":"apiKey","name":"Authorization","in":"header","description":"\nClients authenticate by including a pre-shared API key in the `Authorization` header of each\nrequest after an authorisation method of `GGL-API-KEY`:\n\n`Authorization: GGL-API-KEY C774-B01F-D695-AA4B-215F-A158-AC22-ADEB`\n\nFor a fuller description see [API authentication](api-authentication).\n"},"basic":{"type":"http","scheme":"basic","description":"This is HTTP Basic authentication using a blank username and the API key as the password.\n\nExample:  `Authorization: Basic OkM3NzQtQjAxRi1ENjk1LUFBNEItMjE1Ri1BMTU4LUFDMjItQURFQg==`\n\nThat example is equivalent to the example in the description of the api_Key method:\nprepending a colon to the API key beginning with `C774` then encoding it into Base64\nproduces the 56 characters beginning with `OkM3`.\n\nThe colon is a separator between a username, which is blank in our case, and the password,\nwhich is our API key.\n\nFor a fuller description see [API authentication](api-authentication)\n"}},"schemas":{"MacroDetail":{"title":"Macro detail","description":"[/api/macros/{id}](macros#get-api-macros-id-) returns one of these.\n\nIt contains a block called `updates`.  This is reserved for future development and its\nbehaviour will change in later versions of Command Centre.\n","allOf":[{"$ref":"#/components/schemas/MacroSummary"},{"type":"object","properties":{"description":{"type":"string"},"division":{"type":"object","description":"The division containing this Macro."},"shortName":{"type":"string","maxLength":16,"description":"Short names are not displayed by default.  You must ask for them using the\n'fields' parameter:\n\n`?fields=shortname,...`.\n"},"commands":{"type":"object","description":"The only thing you can do to a macro via REST is run it, so this block only contains one command, and only if your operator is privileged to do that.","properties":{"run":{"type":"object","properties":{"href":{"description":"[POST](macros#post-api-macros-id-run) to this to run this macro.\n","type":"string","format":"uri-reference"}}}}}}}]},"MacroSummary":{"title":"Macro summary","description":"`/api/macros` returns an array of these.  It is a subset of what you get from a\nmacro's detail page at `/api/macros/{id}` (linked as the href in this object).\n","properties":{"href":{"type":"string","format":"uri-reference","description":"A link to a [macro detail](models#macrodetail) object for this macro.\n"},"id":{"type":"string","description":"An alphanumeric identifier, unique to the server.  This is the ID to use in the `source`\nparameter of [event filters](events#get-api-events) if you are only\ninterested in events from particular macros (which would be unusual, since macros do not\ngenerate many events).\n"},"name":{"type":"string"}}}},"responses":{"403nolicence":{"description":"A server running 8.50 or earlier is missing the RESTStatus licence.  A server running 8.60\nor later is missing both the RESTStatus and RESTOverrides licences.  One of those is enough\nfor this API call in 8.60 and later.\n"},"404macro":{"description":"The request's URL does not represent a macro, or the operator does not have a privilege on the\nmacro's division that allows viewing it, such as 'View Site', 'Run Macros', or 'Schedule and\nRun Macros'.\n"}}},"paths":{"/api/macros/{id}":{"get":{"tags":["Macros"],"summary":"Get details of a macro","description":"This returns the detail of one macro.\n\nFollow the 'href' field in a [macro summary](models#macrosummary) to get here.\n","parameters":[{"name":"id","in":"path","required":true,"description":"The ID of the macro.","schema":{"type":"string"}},{"name":"fields","in":"query","required":false,"style":"form","explode":false,"description":"This instructs the server to return only these fields in the details page instead of the default set.  The values you can list\nare the same as the field names you would see in the results.  Use it to cut back on the size\nof the response.  Separate values with commas.\n\nTreat the string matches as case-sensitive.\n\nIn v8.00 you will receive the href and internal ID even if you did not ask for them.  In 8.10\nand later you will only get what you asked for.  If you are going to send the `fields`\nparameter and need the href or ID, be explicit.\n","schema":{"type":"string","enum":["href","id","name","description","division","commands","notes","updates","defaults"]}}],"responses":{"200":{"description":"Success.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/MacroDetail"}}}},"403":{"$ref":"#/components/responses/403nolicence"},"404":{"$ref":"#/components/responses/404macro"}}}}}}
```

## Run a macro

> Sends a run request to a macro.<br>

```json
{"openapi":"3.2.0","info":{"title":"Command Centre REST API","version":"2.0"},"tags":[{"name":"Macros","description":"These methods give you read access to basic data about the Macros in the Command\nCentre database, and let you run them.\n\nReading the section 'Understanding Macros' in the Configuration client help is an\nexcellent way to do exactly that.\n\nThe first use case below introduces the main entry point.  It is a paginated search interface\nthat gives you any number of macros, each containing the fields you ask for in the query,\nincluding (for example) the URL you need to run the macro.\n\nYou cannot use the REST API to change a macro's schedule.  You must use the Command\nCentre or Configuration client for that.\n\n## Overrides\n\nYou can use this API to run a macro.  That is the only override they accept.\n\n## Macro status flags\n\nBeing very simple creatures, macros normally bear no flags of status but an experimental\naddition to version 9.30 adds the flag `closed` while a macro is running.  If you have\nsubscribed to status updates you will see this flag flash past, but if you simply ask for a\nmacro's status on your own schedule you are very unlikely to strike it during the extremely\nbrief time it is active.\n\nThis is a feature meant for Gallagher clients only.  A future version may change the flag's\nname so we suggest avoiding it for now.\n\n### Macro flag rules\n\n* Do not rely on `closed` meaning that the macro is running.\n\n## Use cases\n\n### Listing Macros\n1. `GET /api`.\n2. Follow the link at `features.macros.macros.href`\n   [↪](macros#get-api-macros), appending a search term (described below) to\n   narrow the results if your installation has a lot of macros.\n3. Process the results, following the `next` link until there isn't one.\n\n### Running a Macro\n1. Find the href for the macro using the process above.\n2. GET it.\n4. If your operator is able to run the macro, the results will contain a URL at\n   `commands.run.href`.  [POST](macros#post-api-macros-id-run) to that to run the macro.\n   No body required.\n\n## Licensing\n\nAll the POSTs that override items require RESTOverrides.\n\nIf you have RESTOverrides but not RESTStatus in 8.60 or later, the GETs return enough\ninformation to let you find the item you want to override but they do not return its status.  In\n8.50 and older, the GET will fail without RESTStatus.\n\nThe RESTOverrides and RESTStatus licences do not overlap: to watch the status of an item as well\nas override it, you will need both.\n"}],"servers":[{"url":"https://127.0.0.1:8904"}],"security":[{"API_key":[]},{"basic":[]}],"components":{"securitySchemes":{"API_key":{"type":"apiKey","name":"Authorization","in":"header","description":"\nClients authenticate by including a pre-shared API key in the `Authorization` header of each\nrequest after an authorisation method of `GGL-API-KEY`:\n\n`Authorization: GGL-API-KEY C774-B01F-D695-AA4B-215F-A158-AC22-ADEB`\n\nFor a fuller description see [API authentication](api-authentication).\n"},"basic":{"type":"http","scheme":"basic","description":"This is HTTP Basic authentication using a blank username and the API key as the password.\n\nExample:  `Authorization: Basic OkM3NzQtQjAxRi1ENjk1LUFBNEItMjE1Ri1BMTU4LUFDMjItQURFQg==`\n\nThat example is equivalent to the example in the description of the api_Key method:\nprepending a colon to the API key beginning with `C774` then encoding it into Base64\nproduces the 56 characters beginning with `OkM3`.\n\nThe colon is a separator between a username, which is blank in our case, and the password,\nwhich is our API key.\n\nFor a fuller description see [API authentication](api-authentication)\n"}},"parameters":{"requested_by":{"name":"requested_by","in":"query","required":false,"schema":{"type":"string"},"description":"Attributes this override to the cardholder with this ID rather than the REST operator.\nPrivilege checks will use the operator as normal, but event monitors and reports will state\nthat the person responsible for the override was the attributed cardholder, not the REST\noperator.  The REST operator will appear in a special mention in the event's details.\n\nFirst available in 8.70.  Versions older than 8.70 will ignore the parameter, leaving the\noverride attributed to the REST operator.\n"}},"responses":{"403macrooverride":{"description":"The site does not have the RESTOverrides licence (in which case the body of the result will\nsay so), or the operator does not have a privilege that allows running macros ('Run Macro' or\n'Schedule and Run Macro', unsurprisingly).\n"}}},"paths":{"/api/macros/{id}/run":{"post":{"tags":["Macros"],"summary":"Run a macro","description":"Sends a run request to a macro.\n","parameters":[{"in":"path","name":"id","required":true,"description":"The ID of the macro.","schema":{"type":"string"}},{"$ref":"#/components/parameters/requested_by"}],"responses":{"204":{"description":"Success."},"403":{"$ref":"#/components/responses/403macrooverride"}}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://help.security.gallagher.com/knowledge-hub/developer/rest-api/macros.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
